# remirepo/Fedora spec file for php-laminas-form3
#
# Copyright (c) 2015-2023 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    843056ab671477be0204ceb7f13feaab41193b52
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     laminas
%global gh_project   laminas-form
%global zf_name      zend-form
%global php_home     %{_datadir}/php
%global namespace    Laminas
%global library      Form
%global major        3

%bcond_without       tests

Name:           php-%{gh_project}%{major}
Version:        3.9.0
Release:        1%{?dist}
Summary:        %{namespace} Framework %{library} component version %{major}

License:        BSD-3-Clause
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with tests}
BuildRequires:  php(language) >= 8.0
BuildRequires:  php-date
BuildRequires:  php-intl
BuildRequires:  php-mbstring
BuildRequires:  php-pcre
BuildRequires:  php-spl
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
# Only v3 for build
BuildRequires: (php-autoloader(%{gh_owner}/laminas-hydrator)             >= 4.3.1   with php-autoloader(%{gh_owner}/laminas-hydrator)             < 5)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-inputfilter)          >= 2.19.1  with php-autoloader(%{gh_owner}/laminas-inputfilter)          < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-stdlib)               >= 3.7.1   with php-autoloader(%{gh_owner}/laminas-stdlib)               < 4)
# From composer, "require-dev": {
#        "ext-intl": "*",
#        "doctrine/annotations": "^1.13.3",
#        "laminas/laminas-captcha": "^2.15",
#        "laminas/laminas-coding-standard": "^2.4",
#        "laminas/laminas-db": "^2.16",
#        "laminas/laminas-escaper": "^2.12",
#        "laminas/laminas-eventmanager": "^3.8",
#        "laminas/laminas-filter": "^2.29",
#        "laminas/laminas-i18n": "^2.21",
#        "laminas/laminas-modulemanager": "^2.14",
#        "laminas/laminas-recaptcha": "^3.5",
#        "laminas/laminas-servicemanager": "^3.20",
#        "laminas/laminas-session": "^2.16",
#        "laminas/laminas-text": "^2.9.0",
#        "laminas/laminas-validator": "^2.28",
#        "laminas/laminas-view": "^2.25",
#        "phpunit/phpunit": "^9.5.26",
#        "psalm/plugin-phpunit": "^0.18.4",
#        "vimeo/psalm": "^5.1"
BuildRequires: (php-composer(doctrine/annotations)                       >= 1.13.3  with php-composer(doctrine/annotations)                       < 2)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-captcha)              >= 2.15    with php-autoloader(%{gh_owner}/laminas-captcha)              < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-db)                   >= 2.16    with php-autoloader(%{gh_owner}/laminas-db)                   < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-escaper)              >= 2.12    with php-autoloader(%{gh_owner}/laminas-escaper)              < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-eventmanager)         >= 3.8     with php-autoloader(%{gh_owner}/laminas-eventmanager)         < 4)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-filter)               >= 2.29    with php-autoloader(%{gh_owner}/laminas-filter)               < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-i18n)                 >= 2.21    with php-autoloader(%{gh_owner}/laminas-i18n)                 < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-modulemanager)        >= 2.14    with php-autoloader(%{gh_owner}/laminas-modulemanager)        < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-recaptcha)            >= 3.5     with php-autoloader(%{gh_owner}/laminas-recaptcha)            < 4)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-servicemanager)       >= 3.20    with php-autoloader(%{gh_owner}/laminas-servicemanager)       < 4)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-session)              >= 2.16    with php-autoloader(%{gh_owner}/laminas-session)              < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-text)                 >= 2.9.0   with php-autoloader(%{gh_owner}/laminas-text)                 < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-validator)            >= 2.28    with php-autoloader(%{gh_owner}/laminas-validator)            < 3)
BuildRequires: (php-autoloader(%{gh_owner}/laminas-view)                 >= 2.25    with php-autoloader(%{gh_owner}/laminas-view)                 < 3)
# remirepo:20
%else
BuildRequires:  php-laminas-inputfilter
BuildRequires:  php-laminas-hydrator4
BuildRequires:  php-laminas-stdlib
BuildRequires:  php-doctrine-annotations
BuildRequires:  php-laminas-captcha
BuildRequires:  php-laminas-db
BuildRequires:  php-laminas-escaper
BuildRequires:  php-laminas-eventmanager
BuildRequires:  php-laminas-filter
BuildRequires:  php-laminas-i18n
BuildRequires:  php-laminas-modulemanager
BuildRequires:  php-laminas-recaptcha
BuildRequires:  php-laminas-servicemanager
BuildRequires:  php-laminas-session
BuildRequires:  php-laminas-text
BuildRequires:  php-laminas-validator
BuildRequires:  php-laminas-view
%endif
%global phpunit %{_bindir}/phpunit9
BuildRequires:  phpunit9 >= 9.5.26
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "~8.0.0 || ~8.1.0 || ~8.2.0",
#        "laminas/laminas-hydrator": "^4.3.1",
#        "laminas/laminas-inputfilter": "^2.19.1",
#        "laminas/laminas-stdlib": "^3.7.1"
Requires:       php(language) >= 8.0
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/laminas-hydrator)             >= 4.3.1   with php-autoloader(%{gh_owner}/laminas-hydrator)             < 5)
Requires:      (php-autoloader(%{gh_owner}/laminas-inputfilter)          >= 2.19.1  with php-autoloader(%{gh_owner}/laminas-inputfilter)          < 3)
Requires:      (php-autoloader(%{gh_owner}/laminas-stdlib)               >= 3.7.1   with php-autoloader(%{gh_owner}/laminas-stdlib)               < 4)
# Mandory because of Polyfill
Requires:      (php-autoloader(%{gh_owner}/laminas-servicemanager)       >= 3.15.1  with php-autoloader(%{gh_owner}/laminas-servicemanager)       < 4)
# From composer, "suggest": {
#        "doctrine/annotations": "^1.12, required to use laminas-form annotations support",
#        "laminas/laminas-captcha": "^2.11, required for using CAPTCHA form elements",
#        "laminas/laminas-eventmanager": "^3.4, reuired for laminas-form annotations support",
#        "laminas/laminas-i18n": "^2.12, required when using laminas-form view helpers",
#        "laminas/laminas-recaptcha": "^3.4, in order to use the ReCaptcha form element",
#        "laminas/laminas-servicemanager": "^3.10, required to use the form factories or provide services",
#        "laminas/laminas-view": "^2.14, required for using the laminas-form view helpers"
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8
Suggests:       php-composer(doctrine/annotations)
Suggests:       php-autoloader(%{gh_owner}/laminas-captcha)
Suggests:       php-autoloader(%{gh_owner}/laminas-eventmanager)
Suggests:       php-autoloader(%{gh_owner}/laminas-i18n)
Suggests:       php-autoloader(%{gh_owner}/laminas-recaptcha)
Suggests:       php-autoloader(%{gh_owner}/laminas-view)
%endif
# remirepo:7
%else
Requires:       php-laminas-inputfilter
Requires:       php-laminas-hydrator4
Requires:       php-laminas-stdlib
# Mandory because of Polyfill
Requires:       php-laminas-servicemanager
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.14.3
Requires:       php-date
Requires:       php-intl
Requires:       php-mbstring
Requires:       php-pcre
Requires:       php-spl

Provides:       php-composer(%{gh_owner}/%{gh_project})   = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The %{namespace}\Form is intended primarily as a bridge between your domain models
and the View Layer. It composes a thin layer of objects representing form
elements, an InputFilter, and a small number of methods for binding data to
and from the form and attached objects.

Documentation: https://docs.laminas.dev/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/%{namespace}/InputFilter/autoload.php',
    '%{php_home}/%{namespace}/Stdlib/autoload.php',
    '%{php_home}/%{namespace}/Hydrator4/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Doctrine/Common/Annotations/autoload.php',
    '%{php_home}/%{namespace}/Captcha/autoload.php',
    '%{php_home}/%{namespace}/EventManager/autoload.php',
    '%{php_home}/%{namespace}/I18n/autoload.php',
    '%{php_home}/%{namespace}/ReCaptcha/autoload.php',
    '%{php_home}/%{namespace}/ServiceManager/autoload.php',
    '%{php_home}/%{namespace}/View/autoload.php',
]);
EOF


%install
: Laminas library
mkdir -p   %{buildroot}%{php_home}/%{namespace}/
cp -pr src %{buildroot}%{php_home}/%{namespace}/%{library}%{major}


%check
%if %{with tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/%{namespace}/%{library}%{major}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('%{namespace}Test\\%{library}\\', dirname(__DIR__) . '/test');
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/%{namespace}/Db/autoload.php',
    '%{php_home}/%{namespace}/Escaper/autoload.php',
    '%{php_home}/%{namespace}/Filter/autoload.php',
    '%{php_home}/%{namespace}/ModuleManager/autoload.php',
    '%{php_home}/%{namespace}/Session/autoload.php',
    '%{php_home}/%{namespace}/Text/autoload.php',
    '%{php_home}/%{namespace}/Validator/autoload.php',
]);
EOF


# May fail on local build when laminas-form is installed

: upstream test suite
ret=0
for cmdarg in "php %{phpunit}" php80 php81 php82; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit9} \
      --filter '^((?!(testHtmlEscapingOfMessages|setValidationGroup|testFormCanBeCreatedViaInteractionOfAllManagers|testRendersDatesWithEsCLLocaleDatePattern)).)*$' \
      -d memory_limit=1G || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
# remirepo:1
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/%{namespace}/%{library}%{major}


%changelog
* Thu Mar 16 2023 Remi Collet <remi@remirepo.net> - 3.9.0-1
- update to 3.9.0

* Tue Dec  6 2022 Remi Collet <remi@remirepo.net> - 3.8.0-1
- update to 3.8.0

* Mon Nov 21 2022 Remi Collet <remi@remirepo.net> - 3.7.0-1
- update to 3.7.0

* Mon Nov 21 2022 Remi Collet <remi@remirepo.net> - 3.6.0-1
- update to 3.6.0

* Thu Nov  3 2022 Remi Collet <remi@remirepo.net> - 3.5.1-1
- update to 3.5.1

* Fri Oct 14 2022 Remi Collet <remi@remirepo.net> - 3.5.0-1
- update to 3.5.0
- raise dependency on PHP 8.0

* Mon Aug  1 2022 Remi Collet <remi@remirepo.net> - 3.4.1-1
- update to 3.4.1

* Thu Jul 28 2022 Remi Collet <remi@remirepo.net> - 3.4.0-1
- update to 3.4.0

* Tue Jul 26 2022 Remi Collet <remi@remirepo.net> - 3.3.0-1
- update to 3.3.0
- raise dependency on laminas-inputfilter 2.19.1
- raise dependency on laminas-servicemanager 3.15.1

* Thu Jun 16 2022 Remi Collet <remi@remirepo.net> - 3.2.0-1
- update to 3.2.0
- raise dependency on laminas-hydrator 4.3.1
- raise dependency on laminas-stdlib 3.7.1

* Mon Jan 31 2022 Remi Collet <remi@remirepo.net> - 3.1.1-1
- update to 3.1.1

* Thu Jan  6 2022 Remi Collet <remi@remirepo.net> - 3.1.0-1
- update to 3.1.0
- raise dependency on PHP 7.4
- raise dependency on laminas-hydrator 4.3.0
- raise dependency on laminas-inputfilter 2.13.0
- raise dependency on laminas-stdlib 3.6.1
- rename to php-laminas-form3
- install in /usr/share/php/Laminas/Form3
- remove ZF compatibility layer

* Tue May 25 2021 Remi Collet <remi@remirepo.net> - 2.17.0-1
- update to 2.17.0

* Wed Apr  7 2021 Remi Collet <remi@remirepo.net> - 2.16.3-1
- update to 2.16.3 (no change)

* Tue Mar 23 2021 Remi Collet <remi@remirepo.net> - 2.16.2-1
- update to 2.16.2 (no change)

* Mon Mar 22 2021 Remi Collet <remi@remirepo.net> - 2.16.1-1
- update to 2.16.1

* Fri Mar 19 2021 Remi Collet <remi@remirepo.net> - 2.16.0-1
- update to 2.16.0
- raise dependency on PHP 7.3
- raise dependency on laminas-hydrator 3.2
- raise dependency on laminas-inputfilter 2.10
- raise dependency on laminas-stdlib 3.3
- raise dependency on laminas-zendframework-bridge 1.1
- switch to phpunit9

* Thu Mar 18 2021 Remi Collet <remi@remirepo.net> - 2.15.1-1
- update to 2.15.1
- temporarily disable test suite with PHP 8

* Wed Jul 15 2020 Remi Collet <remi@remirepo.net> - 2.15.0-1
- update to 2.15.0

* Tue Jun 23 2020 Remi Collet <remi@remirepo.net> - 2.14.6-1
- update to 2.14.6

* Mon Mar 30 2020 Remi Collet <remi@remirepo.net> - 2.14.5-1
- update to 2.14.5 (no change)

* Thu Mar 19 2020 Remi Collet <remi@remirepo.net> - 2.14.4-1
- update to 2.14.4

* Mon Jan 20 2020 Remi Collet <remi@remirepo.net> - 2.12.0-2
- allow laminas-hydrator v3

* Wed Jan 15 2020 Remi Collet <remi@remirepo.net> - 2.12.0-1
- switch to Laminas
- add patch for PHP 7.4 from
  https://github.com/laminas/laminas-form/pull/55

* Fri Oct  4 2019 Remi Collet <remi@remirepo.net> - 2.14.3-1
- update to 2.14.3
- drop patch merged upstream

* Fri Oct  4 2019 Remi Collet <remi@remirepo.net> - 2.14.2-1
- update to 2.14.2
- add patch for PHP 7.4 from
  https://github.com/zendframework/zend-form/pull/235

* Wed Feb 27 2019 Remi Collet <remi@remirepo.net> - 2.14.1-1
- update to 2.14.1

* Tue Jan  8 2019 Remi Collet <remi@remirepo.net> - 2.14.0-1
- update to 2.14.0
- raise dependency on zend-stdlib 3.2.1

* Wed Dec 12 2018 Remi Collet <remi@remirepo.net> - 2.13.0-1
- update to 2.13.0
- allow zend-hydrator 3
- use range dependencies

* Wed May 23 2018 Remi Collet <remi@remirepo.net> - 2.12.0-2
- update to 2.12.0

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.11.0-3
- zend-servicemanager is mandatory

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.11.0-2
- switch from zend-loader to fedora/autoloader

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.11.0-1
- Update to 2.11.0
- temporarily switch back to phpunit v5
- raise dependency on zend-inputfilter 2.8
- raise dependency on zend-session 2.8.1

* Tue Oct 24 2017 Remi Collet <remi@remirepo.net> - 2.10.2-3
- fix FTBFS from Koschei, add patch for PHP 7.2 from
  https://github.com/zendframework/zend-form/pull/171

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.10.2-1
- Update to 2.10.2

* Thu Apr 27 2017 Remi Collet <remi@remirepo.net> - 2.10.1-1
- Update to 2.10.1
- raise minimum php version to 5.6
- use phpunit6 on F26+

* Thu Mar  2 2017 Remi Collet <remi@remirepo.net> - 2.10.0-1
- update to 2.10.0
- raise dependency on zend-captcha 2.7.1

* Fri Sep 23 2016 Remi Collet <remi@fedoraproject.org> - 2.9.2-1
- update to 2.9.2

* Thu Sep 15 2016 Remi Collet <remi@fedoraproject.org> - 2.9.1-1
- update to 2.9.1

* Fri Jun 10 2016 Remi Collet <remi@fedoraproject.org> - 2.9.0-1
- update to 2.9.0

* Wed May  4 2016 Remi Collet <remi@fedoraproject.org> - 2.8.3-1
- update to 2.8.3

* Mon May  2 2016 Remi Collet <remi@fedoraproject.org> - 2.8.2-1
- update to 2.8.2
- raise dependency on zend-loader >= 2.5.1-3

* Sun May  1 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-1
- update to 2.8.1

* Fri Apr  8 2016 Remi Collet <remi@fedoraproject.org> - 2.8.0-1
- update to 2.8.0

* Tue Feb 23 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0
- raise dependency on zend-inputfilter >= 2.6
- raise dependency on zend-hydrator >= 1.1

* Thu Jan 28 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-stdlib ~2.7
- add dependency on zend-hydrator ~1.0

* Wed Sep 23 2015 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- update to 2.5.3

* Thu Sep 10 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise minimum php version to 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
